<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPropertiesTypeProperty ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfPropertiesTypeProperty extends AbstractStructArrayBase
{
    /**
     * The PropertiesTypeProperty
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgPropertiesTypeProperty[]
     */
    public $PropertiesTypeProperty;
    /**
     * Constructor method for ArrayOfPropertiesTypeProperty
     * @uses DgArrayOfPropertiesTypeProperty::setPropertiesTypeProperty()
     * @param \dgsoft\StructType\DgPropertiesTypeProperty[] $propertiesTypeProperty
     */
    public function __construct(array $propertiesTypeProperty = array())
    {
        $this
            ->setPropertiesTypeProperty($propertiesTypeProperty);
    }
    /**
     * Get PropertiesTypeProperty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgPropertiesTypeProperty[]|null
     */
    public function getPropertiesTypeProperty()
    {
        return isset($this->PropertiesTypeProperty) ? $this->PropertiesTypeProperty : null;
    }
    /**
     * Set PropertiesTypeProperty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPropertiesTypeProperty[] $propertiesTypeProperty
     * @return \dgsoft\ArrayType\DgArrayOfPropertiesTypeProperty
     */
    public function setPropertiesTypeProperty(array $propertiesTypeProperty = array())
    {
        foreach ($propertiesTypeProperty as $arrayOfPropertiesTypePropertyPropertiesTypePropertyItem) {
            // validation for constraint: itemType
            if (!$arrayOfPropertiesTypePropertyPropertiesTypePropertyItem instanceof \dgsoft\StructType\DgPropertiesTypeProperty) {
                throw new \InvalidArgumentException(sprintf('The PropertiesTypeProperty property can only contain items of \dgsoft\StructType\DgPropertiesTypeProperty, "%s" given', is_object($arrayOfPropertiesTypePropertyPropertiesTypePropertyItem) ? get_class($arrayOfPropertiesTypePropertyPropertiesTypePropertyItem) : gettype($arrayOfPropertiesTypePropertyPropertiesTypePropertyItem)), __LINE__);
            }
        }
        if (is_null($propertiesTypeProperty) || (is_array($propertiesTypeProperty) && empty($propertiesTypeProperty))) {
            unset($this->PropertiesTypeProperty);
        } else {
            $this->PropertiesTypeProperty = $propertiesTypeProperty;
        }
        return $this;
    }
    /**
     * Add item to PropertiesTypeProperty value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPropertiesTypeProperty $item
     * @return \dgsoft\ArrayType\DgArrayOfPropertiesTypeProperty
     */
    public function addToPropertiesTypeProperty(\dgsoft\StructType\DgPropertiesTypeProperty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgPropertiesTypeProperty) {
            throw new \InvalidArgumentException(sprintf('The PropertiesTypeProperty property can only contain items of \dgsoft\StructType\DgPropertiesTypeProperty, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PropertiesTypeProperty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgPropertiesTypeProperty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgPropertiesTypeProperty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgPropertiesTypeProperty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgPropertiesTypeProperty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgPropertiesTypeProperty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PropertiesTypeProperty
     */
    public function getAttributeName()
    {
        return 'PropertiesTypeProperty';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfPropertiesTypeProperty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
